import turtle
import math as m


def main():
    # put label on top of page
    turtle.title('Recursive Figures')

    # setup screen size
    turtle.setup(1000, 1000, 0, 0)

    turtle.tracer(100)
    # Accelerates drawing by updating screen only every n frames.

    # create a turtle object
    t = turtle.Turtle()
    t.speed(0)
    t.ht()

    # draw the sierpinski curve
    t.pu()
    t.setpos(-250, 0)
    t.pd()
    t.pencolor('red')
    t.fillcolor('gold')
    t.begin_fill()
    curve(t, 15, 4)
    t.end_fill()

    # draw gasket
    t.pu()
    t.setpos(-125, 200)
    t.pd()
    t.pencolor('blue')
    t.fillcolor('light green')
    t.begin_fill()
    drawGasket(t, 200)
    t.end_fill()

    turtle.exitonclick()
  

def curve(t, s, level):
    diag = s / m.sqrt(2)
    for iter in range (4):
        oneSide(t, s, diag, level)
        t.right(45)
        t.forward(diag)
        t.right(45)


def drawGasket(t, size):
    if size < 10:
        return
    for iter in range (3):
        t.forward(size / 2)
        insertGasket(t, size)
        t.forward(size / 2)
        t.right(120)


def insertGasket(t, size):
    t.left(120)
    drawGasket(t, size / 2)
    t.right(120)


def oneSide(t, s, diag, level):
    if (level == 0):
        return
    else:
        oneSide(t, s, diag, level - 1)
        t.right(45); t.forward(diag); t.right(45)
        oneSide(t, s, diag, level - 1)
        t.left(90); t.forward(s); t.left(90)
        oneSide(t, s, diag, level - 1)
        t.right(45); t.forward(diag); t.right(45)
        oneSide(t, s, diag, level - 1)


if __name__ == '__main__':
    main()
