# Spiral Phyllotaxis Demo
#
# Example for VSFX 705
# Turtle Sunflowers - Introduce Phyllotactic Pattern
#
# Author: Deborah R. Fowler
#
# March 21, 2013
# Based on original code in C 1989 using Silicon Graphics Workstations and gl


import math as m
import turtle as t


def drawPhyllotacticPattern(tt, petalstart, angle = 137.508, size = 2, cspread = 4 ):
    ''' Print a pattern of circles using spiral phyllotactic data '''
    # initialize position
    t.pen(outline=1, pencolor='black', fillcolor='orange')
    # t.color('orange')
    phi = angle * (m.pi / 180.0)
    xcenter = 0.0
    ycenter = 0.0
   
    # for loops iterate in this case from the first value until < 4, so
    for n in range (0, tt):
        r = cspread * m.sqrt(n)
        theta = n * phi
        
        x = r * m.cos(theta) + xcenter
        y = r * m.sin(theta) + ycenter

        # Move the turtle to that position and draw 
        t.pu()
        t.setpos(x,y)
        t.pd()
        # Orientate the turtle correctly
        t.seth(n * angle)
        if n > petalstart-1:
            #t.color('yellow)
            drawPetal(x,y)
        else:
            t.stamp()
                

def drawPetal( x, y ):
    t.pu()
    t.setpos(x,y)
    t.pd()
    t.begin_fill()
    #t.fill(True)
    t.pen(outline=1, pencolor='black', fillcolor='yellow')
    t.rt(20)
    t.fd(100)
    t.lt(40)
    t.fd(100)
    t.lt(140)
    t.fd(100)
    t.lt(40)
    t.fd(100)
    t.pu()
    t.end_fill()  # This is needed to complete the last petal


t.shape('turtle')
t.speed(0)  # Make the turtle go as fast as possible
drawPhyllotacticPattern(200, 160, 137.508, 4, 10)
t.exitonclick()
