import turtle
import TurtleUtilsPMP as tp
import tkinter.messagebox as mb
import math as m


def main():
    scr = tp.initializescreen()
    ada = tp.initializeturtle()

    scr.tracer(2)

    ada.pencolor('blue')
    ada.pd()
    shape01(ada)

    scr.exitonclick()


def shape01(t):
    theta = 0.015
    sx = 0
    sy = 0

    while (theta < 4 * m.pi):
        xt = m.sin(theta * 10) * 500 + 300
        yt = m.cos(theta * 9.5) * 500 + 300
        nthet = xt / 30 + yt / 30
        yp = yt + m.sin(nthet) * 20
        xp = xt + m.cos(nthet) * 20
        gx = m.sqrt((sx/2-xp/2)**2 + (sy/2-yp/2)**2) # the length of the line
        tx = (xp/2.0) - (sx/2.0)
        ty = (yp/2.0) - (sy/2.0)
        cx = m.atan2(-ty, tx)*(180.0/m.pi) # the angle between the line and the horizontal axis
        t.pd()
        if theta == 0.015:
            t.pu()
        t.lt(cx)     # set the angle
        t.fd(gx)     # move forward the appropriate amount
        t.lt(-1*cx)  # reset the angle so next time we start off from scratch
        sx = xp
        sy = yp
        theta += 0.004


if __name__ == '__main__':
    main()
